<a name="top"></a> module-export
================================
> *A module exporter for Node v4+*

[![npm Version][image-npm]][url-npm]
[![Travis CI][image-tra]][url-tra]
[![Dependency Status][image-dep]][url-dep]
[![Downloads][image-dls]][url-dls]
[![License (MIT)][image-lic]][url-lic]
[![XO Code Style][image-xos]][url-xo]

## Contents
- [Usage](#usage)
- [Testing](#testing)
- [API](#api)

## Usage
***In Progress...***
*Basic usage*:
```
const moduleExport = require('module-export')(module);

moduleExport(() => { ... }); // Export a function

moduleExport({ ... }); // Export an object

class MyClass { ... }
moduleExport(MyClass); // Export a class
```

## Testing
`module-export` uses [`xo`][url-xo] (with slightly customized configuration) for linting, [`ava`][url-ava] for unit testing, and [`nyc`][url-nyc] for coverage.

### Test Scripts
- `npm run lint`: Uses `xo` to lint the main source file, `index.js`.
- `npm run test-lint`: Uses `xo` to lint the test source files, located in `test/`.
- `npm run unit`: Executes `test-lint` and runs the `ava` unit tests using `nyc` for coverage.
- `npm report`: Generates an HTML coverage report from `nyc`.
- `npm run test`: Executes `lint`, `unit` and `report` in that order.

## API
***In Progress...***

[image-dep]: https://dependencyci.com/github/lodicolo/node-module-export/badge
[image-dls]: https://img.shields.io/npm/dm/module-export.svg?style=flat
[image-lic]: http://img.shields.io/npm/l/module-export.svg?style=flat
[image-npm]: https://img.shields.io/npm/v/module-export.svg?style=flat
[image-tra]: http://img.shields.io/travis/lodicolo/node-module-export.svg?style=flat
[image-xos]: https://img.shields.io/badge/code_style-XO-5ed9c7.svg

[url-dep]: https://dependencyci.com/github/lodicolo/node-module-export
[url-dls]: https://npmjs.org/package/module-export
[url-lic]: https://github.com/lodicolo/module-export/blob/master/LICENSE
[url-npm]: https://npmjs.org/package/module-export
[url-tra]: https://travis-ci.org/lodicolo/module-export

[url-ava]: https://github.com/avajs/ava
[url-nyc]: https://github.com/istanbuljs/nyc
[url-xo]: https://github.com/sindresorhus/xo

[lnk-top]: #contents "Go to Contents"
